You need to change the version in the pakfire.conf, too.
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
06209efc 20# Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
06209efc
MT
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
7f5fdd04 27VERSION="2.0rc2" # Version number
06209efc
MT
28SLOGAN="www.ipfire.org" # Software slogan
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
31MAX_RETRIES=1 # prefetch/check loop
15679d9f
MT
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
8f7b33ea 36IPFVER="full" # Which versions should be compiled? (full|devel)
03ad5f93
MT
37
38# Set an information about the build number
15679d9f
MT
39if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41fi
42
43# Debian specific settings
44if [ ! -e /etc/debian_version ]; then
df5e82b3 45 FULLPATH=`which $0`
15679d9f 46else
df5e82b3
MT
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
15679d9f 53fi
df5e82b3 54
15679d9f
MT
55PWD=`pwd`
56BASENAME=`basename $0`
57BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58LOGFILE=$BASEDIR/log/_build.preparation.log
59export BASEDIR LOGFILE
60DIR_CHK=$BASEDIR/cache/check
61mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 62
15679d9f
MT
63# Include funtions
64. tools/make-functions
df5e82b3 65
15679d9f
MT
66if [ -f .config ]; then
67 . .config
68else
6b8cff41
MT
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
15679d9f 76fi
df5e82b3
MT
77
78prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
1b273e8f 85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
df5e82b3
MT
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
1b273e8f 89 exiterror "Not running BASH shell."
df5e82b3
MT
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
9b0ff0a0 106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
df5e82b3
MT
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
1b273e8f
MT
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
15679d9f 111 else
1b273e8f 112 beautify message DONE
df5e82b3
MT
113 fi
114
15679d9f 115
df5e82b3
MT
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
9b0ff0a0 121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
df5e82b3 122 if [ `id -u` != 0 ]; then
1b273e8f
MT
123 beautify message FAIL
124 exiterror "Not building as root"
15679d9f 125 else
1b273e8f 126 beautify message DONE
df5e82b3
MT
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
9b0ff0a0 135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
df5e82b3
MT
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
41921bd9 138 if (( 2048000 > $BASE_ASPACE )); then
1b273e8f
MT
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
15679d9f 144 else
1b273e8f 145 beautify message DONE
df5e82b3
MT
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
df5e82b3
MT
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
1b273e8f 164 ln -s $BASEDIR/build/tools /
df5e82b3
MT
165 fi
166 if [ ! -h /tools ]; then
1b273e8f 167 exiterror "Could not create /tools symbolic link."
df5e82b3
MT
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
1179dc27 173 MAKETUNING="-j6"
dd714b8a 174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
df5e82b3
MT
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
90d372c4 179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
df5e82b3 180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
90d372c4
MT
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
df5e82b3
MT
185
186 # Make all sources and proc available under lfs build
90d372c4 187 mount --bind /dev $BASEDIR/build/dev
857d9bf2
MT
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
df5e82b3
MT
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
119ee469 202 # This is a temporary hack!!!
6b8cff41
MT
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
119ee469 206
df5e82b3
MT
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213}
214
df5e82b3
MT
215buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
df5e82b3
MT
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
15679d9f
MT
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
df5e82b3 224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
dd714b8a
MT
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
9b0ff0a0 227 lfsmake1 cleanup-toolchain PASS=1
df5e82b3
MT
228 lfsmake1 tcl
229 lfsmake1 expect
df5e82b3 230 lfsmake1 dejagnu
15679d9f
MT
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
dd714b8a
MT
233 lfsmake1 ncurses
234 lfsmake1 bash
df5e82b3 235 lfsmake1 bzip2
dd714b8a 236 lfsmake1 coreutils
df5e82b3
MT
237 lfsmake1 diffutils
238 lfsmake1 findutils
dd714b8a 239 lfsmake1 gawk
df5e82b3 240 lfsmake1 gettext
dd714b8a
MT
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
df5e82b3 245 lfsmake1 patch
dd714b8a
MT
246 lfsmake1 perl
247 lfsmake1 sed
df5e82b3
MT
248 lfsmake1 tar
249 lfsmake1 texinfo
df5e82b3 250 lfsmake1 util-linux
9b0ff0a0 251 lfsmake1 cleanup-toolchain PASS=2
df5e82b3
MT
252 export PATH=$ORG_PATH
253}
254
255buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
df5e82b3 258 lfsmake2 stage2
9b0ff0a0 259 lfsmake2 linux-libc-header
df5e82b3
MT
260 lfsmake2 man-pages
261 lfsmake2 glibc
9b0ff0a0 262 lfsmake2 cleanup-toolchain PASS=3
df5e82b3
MT
263 lfsmake2 binutils
264 lfsmake2 gcc
9b0ff0a0 265 lfsmake2 berkeley
df5e82b3 266 lfsmake2 coreutils
df5e82b3 267 lfsmake2 iana-etc
df5e82b3
MT
268 lfsmake2 m4
269 lfsmake2 bison
9b0ff0a0
MT
270 lfsmake2 ncurses
271 lfsmake2 procps
df5e82b3 272 lfsmake2 sed
9b0ff0a0 273 lfsmake2 libtool
df5e82b3 274 lfsmake2 perl
9b0ff0a0
MT
275 lfsmake2 readline
276 lfsmake2 zlib
df5e82b3
MT
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
df5e82b3
MT
280 lfsmake2 bzip2
281 lfsmake2 diffutils
df5e82b3 282 lfsmake2 e2fsprogs
65998e0a 283 lfsmake2 ed
9b0ff0a0
MT
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
9b0ff0a0
MT
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
df5e82b3 291 lfsmake2 gzip
9b0ff0a0
MT
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
44254afd 296 lfsmake2 libaal
df5e82b3 297 lfsmake2 make
9b0ff0a0
MT
298 lfsmake2 man
299 lfsmake2 mktemp
df5e82b3 300 lfsmake2 modutils
65f8f30f 301 lfsmake2 mtd
65998e0a 302 lfsmake2 net-tools
df5e82b3 303 lfsmake2 patch
df5e82b3 304 lfsmake2 psmisc
44254afd 305 lfsmake2 reiser4progs
df5e82b3
MT
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
90d372c4
MT
310 lfsmake2 texinfo
311 lfsmake2 udev
df5e82b3 312 lfsmake2 util-linux
90d372c4 313 lfsmake2 vim
44254afd 314 lfsmake2 grub
df5e82b3
MT
315}
316
15679d9f 317buildipfire() {
907cd036 318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 319 export LOGFILE
15679d9f 320 ipfiremake configroot
dc8b9670 321 ipfiremake backup
15679d9f
MT
322 ipfiremake dhcp
323 ipfiremake dhcpcd
324 ipfiremake libusb
325 ipfiremake libpcap
15679d9f
MT
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
3a1019f6 329 ipfiremake linux SMP=1
552b817b 330 ipfiremake ipp2p SMP=1
dd001658 331 ipfiremake zaptel SMP=1
c3e36980 332 ipfiremake linux
552b817b 333 ipfiremake ipp2p
119f6ad3 334 ipfiremake zaptel
c545beb1 335 ipfiremake pkg-config
a89770fa 336 ipfiremake linux-atm
ad9d4caf 337 ipfiremake cpio
ee78a5ef
MT
338 ipfiremake klibc
339 ipfiremake mkinitcpio
340 ipfiremake udev KLIBC=1
15679d9f
MT
341 ipfiremake expat
342 ipfiremake gdbm
343 ipfiremake gmp
c8ead4a5 344 ipfiremake pam
15679d9f 345 ipfiremake openssl
eac942d9 346 ipfiremake curl
15679d9f
MT
347 ipfiremake python
348 ipfiremake libnet
27b8cc24 349 ipfiremake libidn
ddac6087 350 ipfiremake libjpeg
15679d9f
MT
351 ipfiremake libpng
352 ipfiremake libtiff
fd3e7da0 353 ipfiremake libart
9594506f 354 ipfiremake freetype
15679d9f
MT
355 ipfiremake gd
356 ipfiremake popt
411afd1f 357 ipfiremake pcre
15679d9f
MT
358 ipfiremake slang
359 ipfiremake newt
fd3e7da0 360 ipfiremake libcap
15679d9f 361 ipfiremake pciutils
51f3b7f5 362 ipfiremake usbutils
15679d9f 363 ipfiremake libxml2
c6c9630e 364 ipfiremake libxslt
6b8cff41 365 ipfiremake BerkeleyDB
15679d9f 366 ipfiremake mysql
411afd1f 367 ipfiremake cyrus-sasl
15679d9f
MT
368 ipfiremake openldap
369 ipfiremake apache2
370 ipfiremake php
a10ae6cc 371 ipfiremake apache2 PASS=C
15679d9f
MT
372 ipfiremake arping
373 ipfiremake beep
374 ipfiremake bind
15679d9f
MT
375 ipfiremake cdrtools
376 ipfiremake dnsmasq
377 ipfiremake dosfstools
444973a4 378 ipfiremake squashfstools
72d80898 379 ipfiremake reiserfsprogs
93afd047 380 ipfiremake sysfsutils
8e055e65 381 ipfiremake fuse
d02350a2 382 ipfiremake ntfs-3g
15679d9f
MT
383 ipfiremake ethtool
384 ipfiremake ez-ipupdate
385 ipfiremake fcron
e3670217 386 ipfiremake perl-GD
330345c2 387 ipfiremake GD-Graph
786f2c8a 388 ipfiremake GD-TextUtil
15679d9f
MT
389 ipfiremake gnupg
390 ipfiremake hdparm
f9956330 391 ipfiremake sdparm
7861f575 392 ipfiremake mtools
15679d9f 393 ipfiremake initscripts
406f019f 394 ipfiremake whatmask
15679d9f 395 ipfiremake iptables
490256d5 396 ipfiremake libupnp
552b817b 397 ipfiremake ipp2p IPT=1
490256d5 398 ipfiremake linux-igd
15679d9f
MT
399 ipfiremake ipac-ng
400 ipfiremake ipaddr
15679d9f 401 ipfiremake iptstate
fd3e7da0 402 ipfiremake iputils
15679d9f 403 ipfiremake l7-protocols
8bba2965 404 ipfiremake mISDN
93afd047 405 ipfiremake hwdata
72d80898 406 ipfiremake kudzu
15679d9f
MT
407 ipfiremake logrotate
408 ipfiremake logwatch
15679d9f 409 ipfiremake misc-progs
15679d9f 410 ipfiremake nano
15679d9f
MT
411 ipfiremake nasm
412 ipfiremake URI
413 ipfiremake HTML-Tagset
414 ipfiremake HTML-Parser
415 ipfiremake Compress-Zlib
416 ipfiremake Digest
417 ipfiremake Digest-SHA1
418 ipfiremake Digest-HMAC
419 ipfiremake libwww-perl
420 ipfiremake Net-DNS
421 ipfiremake Net-IPv4Addr
422 ipfiremake Net_SSLeay
423 ipfiremake IO-Stringy
424 ipfiremake Unix-Syslog
425 ipfiremake Mail-Tools
426 ipfiremake MIME-Tools
427 ipfiremake Net-Server
428 ipfiremake Convert-TNEF
429 ipfiremake Convert-UUlib
430 ipfiremake Archive-Tar
431 ipfiremake Archive-Zip
432 ipfiremake Text-Tabs+Wrap
433 ipfiremake Locale-Country
93afd047 434 ipfiremake XML-Parser
c5568d64 435 ipfiremake glib
15679d9f
MT
436 ipfiremake GeoIP
437 ipfiremake fwhits
438 ipfiremake noip_updater
439 ipfiremake ntp
15679d9f
MT
440 ipfiremake openssh
441 ipfiremake openswan
15679d9f
MT
442 ipfiremake rrdtool
443 ipfiremake setserial
444 ipfiremake setup
445 ipfiremake snort
8a5604bf 446 ipfiremake oinkmaster
15679d9f
MT
447 ipfiremake squid
448 ipfiremake squid-graph
449 ipfiremake squidguard
069ae085 450 ipfiremake calamaris
6f00de0d 451 ipfiremake tcpdump
15679d9f
MT
452 ipfiremake traceroute
453 ipfiremake vlan
454 ipfiremake wireless
455 ipfiremake libsafe
15679d9f 456 ipfiremake pakfire
15679d9f 457 ipfiremake java
15679d9f
MT
458 ipfiremake spandsp
459 ipfiremake lzo
460 ipfiremake openvpn
15679d9f 461 ipfiremake pammysql
15679d9f 462 ipfiremake cups
fccb3371
MT
463 ipfiremake ghostscript
464 ipfiremake foomatic
15679d9f
MT
465 ipfiremake samba
466 ipfiremake sudo
467 ipfiremake mc
468 ipfiremake wget
15679d9f
MT
469 ipfiremake bridge-utils
470 ipfiremake screen
471 ipfiremake hddtemp
472 ipfiremake smartmontools
473 ipfiremake htop
15679d9f 474 ipfiremake postfix
15679d9f 475 ipfiremake fetchmail
5ad5a6bc 476 ipfiremake cyrus-imapd
58493e1e 477 ipfiremake openmailadmin
15679d9f 478 ipfiremake clamav
15679d9f 479 ipfiremake spamassassin
fd3e7da0 480 ipfiremake amavisd
0708852c 481 ipfiremake alsa
15679d9f 482 ipfiremake mpg123
a28fdc01 483 ipfiremake mpfire
6c98857b 484 ipfiremake guardian
67081922 485 ipfiremake libid3tag
15679d9f
MT
486 ipfiremake libmad
487 ipfiremake libogg
488 ipfiremake libvorbis
489 ipfiremake lame
15679d9f 490 ipfiremake sox
a6931e7e
MT
491 ipfiremake libshout
492 ipfiremake icecast
909d16ee 493 ipfiremake icegenerator
71043200 494 ipfiremake mpd
f86b0cc3 495 ipfiremake mpc
24fd09e4
MT
496 ipfiremake xvid
497 ipfiremake libmpeg2
24fd09e4 498 ipfiremake videolan
0708852c 499 ipfiremake libpri
0708852c 500 ipfiremake asterisk
15679d9f 501 ipfiremake gnump3d
eac942d9 502 ipfiremake libsigc++
15679d9f
MT
503 ipfiremake applejuice
504 ipfiremake ocaml
505 ipfiremake mldonkey
eac942d9
MT
506 ipfiremake libtorrent
507 ipfiremake rtorrent
06209efc 508 ipfiremake ipfireseeder
15679d9f
MT
509 ipfiremake rsync
510 ipfiremake tcpwrapper
511 ipfiremake portmap
512 ipfiremake nfs
513 ipfiremake nmap
514 ipfiremake mbmon
15679d9f 515 ipfiremake ncftp
15679d9f 516 ipfiremake etherwake
06da1292 517 ipfiremake bwm-ng
1a8688ba
MT
518 ipfiremake tripwire
519 ipfiremake sysstat
a08c3a2e 520 ipfiremake vsftpd
51f3b7f5 521 ipfiremake which
186e3d2c 522 ipfiremake lsof
c5e5a5aa 523 ipfiremake centerim
d83f547d 524 ipfiremake br2684ctl
df5e82b3
MT
525}
526
527buildinstaller() {
528 # Run installer scripts one by one
529 LOGFILE="$BASEDIR/log/_build.installer.log"
530 export LOGFILE
0afc6d83 531 ipfiremake syslinux
4dc82852
MT
532 ipfiremake as86
533 ipfiremake mbr
fd0763dc 534 ipfiremake memtest
bc9f0c12
MT
535 installmake linux-libc-header
536 installmake binutils
537 ipfiremake uClibc PASS=1
538 ipfiremake gcc INST=1
539 installmake uClibc PASS=2
540 installmake gcc INST=2
541 installmake uClibc PASS=3
df5e82b3 542 installmake busybox
c66941dd 543 installmake udev
33634aa8
MT
544 installmake slang
545 installmake newt
72d80898 546 installmake gettext
33634aa8
MT
547 installmake kbd
548 installmake popt
33634aa8 549 installmake sysvinit
df5e82b3 550 installmake misc-progs
44254afd
MT
551 installmake libaal
552 installmake reiser4progs
89069053 553 installmake reiserfsprogs
a6316ce4 554 installmake sysfsutils
df5e82b3 555 installmake util-linux
df5e82b3 556 installmake pciutils
c5568d64 557 installmake zlib
65f8f30f 558 installmake mtd
c78a77eb 559 installmake wget
93afd047 560 installmake hwdata
fcb5057d 561 installmake kudzu
df5e82b3 562 installmake installer
df5e82b3 563 installmake initrd
df5e82b3
MT
564}
565
566buildpackages() {
567 LOGFILE="$BASEDIR/log/_build.packages.log"
568 export LOGFILE
569 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 570
edd536b6 571 installmake strip
df5e82b3
MT
572
573 # Generating list of packages used
0fbb45e9 574 echo -n "Generating packages list from logs" | tee -a $LOGFILE
df5e82b3
MT
575 rm -f $BASEDIR/doc/packages-list
576 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
577 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 578 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
579 fi
580 done
7471f6ab 581 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 582 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
583 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
584 rm -f $BASEDIR/doc/packages-list
c9673262 585 # packages-list.txt is ready to be displayed for wiki page
0fbb45e9 586 beautify message DONE
df5e82b3 587
9607771a 588 # Create images for install
74dbbc36
MT
589 ipfiremake cdrom ED=full
590
4dc82852 591 # Check if there is a loop device for building in virtual environments
eedc26d9 592 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
4dc82852
MT
593 ipfiremake usb-stick
594 fi
4dc82852 595 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
c9673262 596
0d909a4a 597 ipfirepackages
e67a57fe
MT
598
599 # Cleanup
600 stdumount
601 rm -rf $BASEDIR/build/tmp/*
602
603 # Generating total list of files
0d909a4a 604 echo -n "Generating files list from logs" | tee -a $LOGFILE
e67a57fe
MT
605 rm -f $BASEDIR/log/FILES
606 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
607 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
608 echo "##" >>$BASEDIR/log/FILES
609 echo "## `basename $i`" >>$BASEDIR/log/FILES
610 echo "##" >>$BASEDIR/log/FILES
611 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
612 fi
613 done
0d909a4a 614 beautify message DONE
e67a57fe
MT
615
616 cd $PWD
e67a57fe
MT
617}
618
619ipfirepackages() {
a5997a4c 620 ipfiremake core-updates
fe7fe395 621 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
453b418b
MT
622 if [ -e $BASEDIR/lfs/$i ]; then
623 ipfiredist $i
624 else
625 echo -n $i
626 beautify message SKIP
627 fi
fe7fe395 628 done
78331e30 629 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 630 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 631 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
632}
633
634# See what we're supposed to do
635case "$1" in
636build)
9729e787 637 clear
df5e82b3 638 BUILDMACHINE=`uname -m`
712d859c 639 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
df5e82b3 640 #only restore on a clean disk
9b0ff0a0 641 if [ ! -f log/cleanup-toolchain-2-tools ]; then
df5e82b3 642 if [ ! -n "$PACKAGE" ]; then
15679d9f 643 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
644 prepareenv
645 buildtoolchain
646 else
647 PACKAGENAME=${PACKAGE%.tar.gz}
15679d9f 648 beautify build_stage "Packaged toolchain compilation"
df5e82b3
MT
649 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
650 tar zxf $PACKAGE
651 prepareenv
652 else
653 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
654 fi
655 fi
656 else
9729e787
MT
657 echo -n "Using installed toolchain" | tee -a $LOGFILE
658 beautify message SKIP
df5e82b3
MT
659 prepareenv
660 fi
5cfe86e6 661
7ab7a9b4 662 beautify build_start
0b59f25c 663 beautify build_stage "Building LFS"
df5e82b3 664 buildbase
15679d9f 665
0b59f25c 666 beautify build_stage "Building IPFire"
15679d9f 667 buildipfire
5cfe86e6
HS
668
669 # Setzen des IPFire Builds
8af06406 670 if [ "$FIREBUILD" ]; then
e57bc1fd 671 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6 672 else
e57bc1fd 673 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6
HS
674 fi
675
0b59f25c 676 beautify build_stage "Building installer"
df5e82b3 677 buildinstaller
15679d9f 678
0b59f25c 679 beautify build_stage "Building packages"
df5e82b3 680 buildpackages
7ab7a9b4 681 beautify build_end
df5e82b3
MT
682 ;;
683shell)
684 # enter a shell inside LFS chroot
685 # may be used to changed kernel settings
686 prepareenv
687 entershell
688 ;;
689changelog)
d1dd6669 690 echo -n "Loading new Changelog from SVN: "
223ad6a4 691 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
a50d04ab 692 beautify message DONE
df5e82b3 693 ;;
df5e82b3 694clean)
a50d04ab 695 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
df5e82b3
MT
696 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
697 $LOSETUP -d $i 2>/dev/null
698 done
699 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
700 umount $i
701 done
702 stdumount
703 for i in `seq 0 7`; do
704 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
705 umount /dev/loop${i} 2>/dev/null;
706 losetup -d /dev/loop${i} 2>/dev/null;
707 fi;
708 done
709 rm -rf $BASEDIR/build
710 rm -rf $BASEDIR/cdrom
f9315063 711 rm -rf $BASEDIR/packages
df5e82b3 712 rm -rf $BASEDIR/log
df5e82b3
MT
713 if [ -h /tools ]; then
714 rm -f /tools
715 fi
a50d04ab 716 beautify message DONE
df5e82b3 717 ;;
c3db995c 718downloadsrc)
df5e82b3
MT
719 if [ ! -d $BASEDIR/cache ]; then
720 mkdir $BASEDIR/cache
721 fi
722 mkdir -p $BASEDIR/log
857d9bf2 723 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
724 FINISHED=0
725 cd $BASEDIR/lfs
726 for c in `seq $MAX_RETRIES`; do
727 if (( FINISHED==1 )); then
728 break
729 fi
730 FINISHED=1
731 cd $BASEDIR/lfs
732 for i in *; do
733 if [ -f "$i" -a "$i" != "Config" ]; then
e22c7973 734 echo -ne "Loading $i"
df5e82b3
MT
735 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
736 if [ $? -ne 0 ]; then
e22c7973 737 beautify message FAIL
df5e82b3
MT
738 FINISHED=0
739 else
740 if [ $c -eq 1 ]; then
e22c7973 741 beautify message DONE
df5e82b3
MT
742 fi
743 fi
744 fi
745 done
746 done
e22c7973 747 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
748 ERROR=0
749 for i in *; do
750 if [ -f "$i" -a "$i" != "Config" ]; then
751 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
752 if [ $? -ne 0 ]; then
e22c7973
MT
753 echo -ne "MD5 difference in lfs/$i"
754 beautify message FAIL
df5e82b3
MT
755 ERROR=1
756 fi
757 fi
758 done
759 if [ $ERROR -eq 0 ]; then
e22c7973
MT
760 echo -ne "${BOLD}all files md5sum match${NORMAL}"
761 beautify message DONE
762 else
763 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
764 beautify message FAIL
df5e82b3 765 fi
e22c7973 766 cd - >/dev/null 2>&1
df5e82b3 767 ;;
df5e82b3 768toolchain)
9729e787 769 clear
df5e82b3 770 prepareenv
15679d9f 771 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
772 buildtoolchain
773 BUILDMACHINE=`uname -m`
774 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
712d859c
MT
775 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
776 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
df5e82b3
MT
777 build/{bin,etc,usr/bin,usr/local} \
778 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
779 log >> $LOGFILE
712d859c
MT
780 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
781 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
df5e82b3
MT
782 stdumount
783 ;;
784gettoolchain)
785 BUILDMACHINE=`uname -m`
786 # arbitrary name to be updated in case of new toolchain package upload
c6cb9d25 787 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
712d859c 788 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
5bd13f01 789 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
712d859c
MT
790 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
791 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
792 cd $BASEDIR/cache/toolchains
5bd13f01 793 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c
MT
794 if [ $? -ne 0 ]; then
795 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
40a4ea4c 796 else
712d859c
MT
797 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
798 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
799 else
800 exiterror "$PACKAGE.md5 did not match, check downloaded package"
801 fi
40a4ea4c 802 fi
712d859c
MT
803 else
804 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
805 fi
806 ;;
15679d9f 807othersrc)
ce56e927 808 prepareenv
15679d9f 809 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
ce56e927
MT
810 chroot $LFS /tools/bin/env -i HOME=/root \
811 TERM=$TERM PS1='\u:\w\$ ' \
812 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
813 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
814 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
815 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
15679d9f
MT
816 if [ $? -eq "0" ]; then
817 beautify message DONE
818 else
819 beautify message FAIL
820 fi
ce56e927
MT
821 stdumount
822 ;;
c6cb9d25
MT
823svn)
824 case "$2" in
825 update|up)
cc0e56be 826 # clear
15679d9f 827 echo -ne "Loading the latest source files...\n"
7471f6ab
MT
828 if [ $3 ]; then
829 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
830 else
831 svn update | tee -a $PWD/log/_build.svn.update.log
832 fi
15679d9f
MT
833 if [ $? -eq "0" ]; then
834 beautify message DONE
c6cb9d25 835 else
15679d9f 836 beautify message FAIL
c6cb9d25
MT
837 exit 1
838 fi
15679d9f 839 echo -ne "Writing the svn-info to a file"
c6cb9d25 840 svn info > $PWD/svn_status
15679d9f
MT
841 if [ $? -eq "0" ]; then
842 beautify message DONE
c6cb9d25 843 else
15679d9f 844 beautify message FAIL
c6cb9d25
MT
845 exit 1
846 fi
712d859c 847 chmod 755 $0
cc0e56be 848 exit 0
c6cb9d25
MT
849 ;;
850 commit|ci)
851 clear
6b8cff41
MT
852 if [ -f /usr/bin/mcedit ]; then
853 export EDITOR=/usr/bin/mcedit
73d9a908
MT
854 fi
855 if [ -f /usr/bin/nano ]; then
856 export EDITOR=/usr/bin/nano
6b8cff41
MT
857 fi
858 echo -ne "Selecting editor $EDITOR..."
859 beautify message DONE
d79b46cb 860 if [ -e /sbin/yast ]; then
028698e8
MT
861 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
862 $0 changelog
863 fi
d79b46cb 864 fi
8a5f0f44 865 update_langs
15679d9f 866 svn commit
c6cb9d25 867 $0 svn up
1065bfea
MT
868 if [ -n "$FTP_CACHE_URL" ]; then
869 $0 uploadsrc
870 fi
c6cb9d25
MT
871 ;;
872 dist)
7471f6ab
MT
873 if [ $3 ]; then
874 SVN_REVISION=$3
875 fi
876 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
877 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
878 exit 0
879 fi
880 echo -en "REV $SVN_REVISION: Downloading..."
223ad6a4
MT
881 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
882 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
883 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
15679d9f
MT
884 evaluate 1
885
7471f6ab
MT
886 echo -en "REV $SVN_REVISION: Compressing files..."
887 if [ -e ipfire-source/trunk/make.sh ]; then
888 chmod 755 ipfire-source/trunk/make.sh
889 fi
9dc02b38 890 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
15679d9f 891 evaluate 1
7471f6ab 892 echo -en "REV $SVN_REVISION: Cleaning up..."
c6cb9d25 893 rm ipfire-source/ -r
15679d9f 894 evaluate 1
7471f6ab 895 ;;
028698e8 896 diff|di)
1a8688ba 897 update_langs
15679d9f 898 echo -ne "Make a local diff to last svn revision"
c6cb9d25 899 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
15679d9f 900 evaluate 1
c6cb9d25 901 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
bf7c473f 902 svn status
c6cb9d25
MT
903 ;;
904 esac
f9315063 905 ;;
15679d9f
MT
906uploadsrc)
907 PWD=`pwd`
908 cd $BASEDIR/cache/
909 echo -e "Uploading cache to ftp server:"
fd1b8061 910 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
15679d9f 911 for i in *; do
fd1b8061
MT
912 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
913 grep -q $(basename $i) /tmp/ftplist
0eab8e84 914 if [ "$?" -ne "0" ]; then
fd1b8061
MT
915 echo -ne "$(basename $i)"
916 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
6fb8ec08 917 if [ "$?" -ne "0" ]; then
15679d9f 918 beautify message FAIL
0eab8e84
MT
919 fi
920 fi
921 done
6fb8ec08 922 rm -f /tmp/ftplist
15679d9f
MT
923 cd $PWD
924 exit 0
0eab8e84 925 ;;
cc0e56be 926upload)
b2c64f8c
MT
927 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
928 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
929 if [ -z $FTP_ISO_PORT ]; then
930 FTP_ISO_PORT=21
931 fi
932 cat <<EOF > .ftp-commands
de2c999d 933mkdir -p $FTP_ISO_PATH$SVN_REVISION
b2c64f8c 934mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
9dc02b38
MT
935quit
936EOF
b2c64f8c
MT
937 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
938 rm -f .ftp-commands
939
940 case "$2" in
941 iso)
942 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
943
8f55c54e 944 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
dff9df9d
MT
945 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
946 if [ -e "$i" ]; then
b2c64f8c
MT
947 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
948 if [ "$?" -eq "0" ]; then
949 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
950 else
951 echo "There was an error while uploading the file $i to the ftp server."
952 exit 1
953 fi
dff9df9d 954 fi
b2c64f8c 955 done
a4c9c660 956 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
6aae8d61 957 if [ "$3" = "--with-sources-cd" ]; then
b2c64f8c 958 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
6aae8d61 959 fi
cc0e56be
MT
960 ;;
961 paks)
b2c64f8c 962 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
cc0e56be 963 if [ "$?" -eq "0" ]; then
822c5bd0 964 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
cc0e56be
MT
965 else
966 echo -e "There was an error while uploading the packages to the ftp server."
712d859c 967 exit 1
cc0e56be
MT
968 fi
969 ;;
970 esac
0d0521b6 971 ;;
cc0e56be 972batch)
c8582074 973 if [ "$2" = "--background" ]; then
15679d9f
MT
974 batch_script
975 exit $?
976 fi
27ac55bf 977 if [ `screen -ls | grep -q ipfire` ]; then
712d859c
MT
978 echo "Build is already running, sorry!"
979 exit 1
980 else
27ac55bf
MT
981 if [ "$2" = "--rebuild" ]; then
982 export IPFIRE_REBUILD=1
983 echo "REBUILD!"
984 else
985 export IPFIRE_REBUILD=0
986 fi
15679d9f
MT
987 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
988 screen -dmS ipfire $0 batch --background
989 evaluate 1
712d859c
MT
990 exit 0
991 fi
cc0e56be 992 ;;
028698e8 993watch)
15679d9f 994 watch_screen
028698e8 995 ;;
33634aa8
MT
996pxe)
997 case "$2" in
998 start)
999 start_tftpd
1000 ;;
1001 stop)
1002 stop_tftpd
1003 ;;
a50d04ab 1004 reload|restart)
33634aa8
MT
1005 reload_tftpd
1006 ;;
1007 esac
1008 exit 0
1009 ;;
bf7c473f
MT
1010lang)
1011 update_langs
1012 ;;
6b8cff41 1013"")
24a4a744
MT
1014 clear
1015 svn info
c3db995c 1016 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
24a4a744
MT
1017 do
1018 case $name in
c3db995c
MT
1019 "IPFIRE: Downloadsrc")
1020 $0 downloadsrc
c6cb9d25
MT
1021 ;;
1022 "IPFIRE: Build (silent)")
1023 $0 build-silent
1024 ;;
1025 "IPFIRE: Watch Build")
028698e8 1026 $0 watch
c6cb9d25 1027 ;;
712d859c
MT
1028 "IPFIRE: Batch")
1029 $0 batch
1030 ;;
c6cb9d25
MT
1031 "IPFIRE: Clean")
1032 $0 clean
1033 ;;
c6cb9d25
MT
1034 "SVN: Update")
1035 $0 svn update
1036 ;;
c6cb9d25 1037 "Help")
a50d04ab 1038 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
c6cb9d25
MT
1039 cat doc/make.sh-usage
1040 ;;
712d859c
MT
1041 "LOG: Tail")
1042 tail -f log/_*
1043 ;;
c6cb9d25
MT
1044 "Exit")
1045 break
1046 ;;
24a4a744
MT
1047 esac
1048 done
df5e82b3 1049 ;;
a50d04ab
MT
1050config)
1051 make_config
1052 ;;
6b8cff41 1053*)
a50d04ab 1054 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
6b8cff41
MT
1055 cat doc/make.sh-usage
1056 ;;
3ea75603 1057esac